/////////////////////////////////////////////////////////////////////////////
// SharedMemory.cpp
/////////////////////////////////////////////////////////////////////////////
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <signal.h>
#include <termios.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "smem.h"


/////////////////////////////////////////////////////////////////////////////
CSharedMemory::CSharedMemory()
{
   ShMem=(void *)0;
   shmid=-1;
   Create("1324",100);
   
} // CSharedMemory::CSharedMemory


/////////////////////////////////////////////////////////////////////////////
CSharedMemory::~CSharedMemory()
{
   
} // CSharedMemory::~CSharedMemory


/////////////////////////////////////////////////////////////////////////////
BOOL CSharedMemory::Create(LPCTSTR Name, DWORD Size)
{

//printf("Create Sharem mem\n");
   shmid=shmget((key_t)1234,SIZE_SH_MEM,0666 | IPC_CREAT);

	if(shmid==-1){
		perror("SHMEM :");
		return FALSE;
	}

	ShMem=shmat(shmid,(void *)0,0);
	if(ShMem == (void *)-1){
		perror("shmat :");
		return FALSE;
	}
//printf("Pamiec %X\n",(int)ShMem);
	return TRUE;
//getchar();
} // CSharedMemory::Create


/////////////////////////////////////////////////////////////////////////////
void CSharedMemory::Destroy()
{
   if(shmdt(ShMem)==-1){
		perror(" shmdt: ");
		return;
	}
	if(shmctl(shmid,IPC_RMID,0)==-1){
		perror(" shmid: ");
		return;
	}	
} // CSharedMemory::Destroy


/////////////////////////////////////////////////////////////////////////////
BOOL CSharedMemory::Set(BYTE Ch, DWORD Len, DWORD Offset)
{
	ShMemS=(struct ShMemStr *)ShMem;
	ShMemS->flag=1;
	memset(ShMemS->t+Offset,Ch,Len);
	return TRUE;
    
} // CSharedMemory::Set


/////////////////////////////////////////////////////////////////////////////
BOOL CSharedMemory::Write(BYTE *Buff, DWORD Len, DWORD Offset)
{
printf("Sharem mem write \n");
    ShMemS=(struct ShMemStr *)ShMem;
	ShMemS->flag=1;
	memcpy(ShMemS->t+Offset,Buff,Len);
	return TRUE;
} // CSharedMemory::Write


/////////////////////////////////////////////////////////////////////////////
BOOL CSharedMemory::Read(BYTE *Buff, DWORD Len, DWORD Offset)
{
   ShMemS=(struct ShMemStr *)ShMem;
	
	if(ShMemS->flag==1){
		printf("Read flag=%d,str=%s\n",ShMemS->flag,ShMemS->t);
		memcpy(Buff,ShMemS->t+Offset,Len);
		ShMemS->flag=0;
		return TRUE;
	}
	return FALSE;
} // CSharedMemory::Read

// EOF //////////////////////////////////////////////////////////////////////
