/////////////////////////////////////////////////////////////////////////////
// SharedMemory.h
/////////////////////////////////////////////////////////////////////////////
#include "linux_type.h"
#ifndef _SharedMemory_h_
#define _SharedMemory_h_

#define SIZE_SH_MEM 100
struct ShMemStr{
	int flag;
	char t[255];
};

class CSharedMemory
{
public:
   CSharedMemory();
   ~CSharedMemory();

   BOOL Create(LPCTSTR Name, DWORD Size);
   void Destroy();

   BOOL Set(BYTE Ch, DWORD Len, DWORD Offset);
   BOOL Write(BYTE *Buff, DWORD Len, DWORD Offset=0);
   BOOL Read(BYTE *Buff, DWORD Len, DWORD Offset=0);

private:
	void *ShMem;
	struct ShMemStr *ShMemS;
	int shmid;   
   
   DWORD m_Size;
};
 
#endif // _SharedMemory_h_

// EOF //////////////////////////////////////////////////////////////////////
