///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/19 12:09:58 $
//         $Locker:  $
//         $Revision: 1.13 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Generowanie plikw htm
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: html.cpp,v $
// Revision 1.13  2004/07/19 12:09:58  ltokarski
// Z0018 - bdne wyswietlanie stron przy pustej lokalizacji, inne poprawki w htmlach
//
// Revision 1.12  2004/07/09 11:20:47  ltokarski
// Z0015 - dodane pozostale parametry do statusu
//
// Revision 1.11  2004/07/05 09:09:43  ltokarski
// Z0011 - rozne drobne poprawki (html cd., blad waitpid, taby przed warningiem, CString operator ==, wyciete debugi)
//
// Revision 1.10  2004/07/02 09:12:54  ltokarski
// Z0010 - drobne poprawki w html
//
// Revision 1.9  2004/06/29 16:16:09  ltokarski
// Z0008 - przechodzenie do tla dopiero po zainicjowaniu i zwracanie kodu bledu
//
// Revision 1.8  2004/06/23 14:02:34  ltokarski
// Z0007 - poprawiona sciezka do images
//
// Revision 1.7  2004/06/23 08:40:32  ltokarski
// Z0004 - zmienna czestosc odswiezania www
//
// Revision 1.5  2004/06/09 14:16:29  ltokarski
// Z0002 - zwracanie bdw do KillAll
//
// Revision 1.4  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "cstr.h"
#include "linux_ty.h"
#include "netdatag.h"
#include "upsmon.h"
#include "upsconfig.h"
#include "upslog.h"
#include "mailcln.h"
#include "smem.h"
#include "html.h"		//definy do tworzenia stron
#include "main.h"

#define MAX_NO_RESPONSE 3

extern char ver[];
extern char datReal[];

extern CDlgMain UpsDlg;
extern CDlgMain *m_UpsDlg;
extern CUPSMonConfig m_Cfg;
extern int __debug;

//void TrimLeft(char *s);
//void TrimRight(char *s);

///////////////
//

void	Windows2ISO(const char *s, char *d)
{
	char iso[] = "ʦѬӣ";
	char windows[] = "ʌяӣ";
	int	i, j;
	for(i = 0; s[i]; i++)
	{
		d[i] = s[i];
		if((signed char)s[i] > 0)
			continue;
		for(j = 0; windows[j]; j++)
		{
			if(d[i] == windows[j])
			{
				d[i] = iso[j];
				break;
			}
		}
	}
	d[i] = 0;
}

//Wtek gwny
int CDlgMain::OnUPSMonStart(int ReadConfigOK)
{
	char fi[255];
	int res;
	FILE *f;

	//initUpsPanel(0);
	sprintf(fi,"%sindex.html",(char *)m_Cfg.m_pathLogWWW);	//Z0010, LT - bylo: htm
	if((f = fopen(fi,"w")) == NULL )
	{
		printf("Open file %s ERROR (3)\n",fi);
		perror("Open file :       ");
		return ERR_FOPEN_INDEX;     //Z0002, LT cant open log file !
	}
	createListWWW(m_AllUPS, 0, SizeAllUps, f, "index");
	res=fclose (f);
	if(res==-1)
		perror("FClose :");
	return 0;	//Z0008, LT
}

/////////////////////////////////////////////////////////////////////////////
//Watek gwny
void CDlgMain::createListWWW(CUPSConfig *AllUps, int Idx,int s_all,FILE *f,char *fileRefresh)
{
//Z0018, LT - nieuzywane	int j;
	time_t time_e;

	fprintf(f,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n"
		"\"http://www.w3.org/TR/html4/loose.dtd\">");
	fprintf(f,"<html>");
	fprintf(f,"<head>");
	fprintf(f,"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-2\">");
	fprintf(f,"<meta name=\"Author\" content=\"Pawel Abramczuk\">");
	fprintf(f,"<meta name=\"GENERATOR\" content=\"Mozilla/4.78 [en] (Win98; U) [Netscape]\">");

	if(m_Cfg.m_refresh > 0)	//Z0004, LT
		fprintf(f,"<META http-equiv=\"Refresh\" content=\"%d; url=%s.html\">", m_Cfg.m_refresh, fileRefresh);	//Z0004, LT	//Z0010, LT - bylo: htm
	fprintf(f,"<title>UPS Monitor 3.0 Unix wersja %s data %s</title>",ver,datReal);

	fprintf(f,"</head>\n");
	fprintf(f,"<BODY BACKGROUND=\"images/tlo.gif\" text=\"navy\" LINK=\"red\" VLINK=\"red\">\n");	//Z0007, LT
	fprintf(f,"<IMG SRC=\"images/logo.gif\" ALT=\"logo\"><br>\n");	//Z0007, LT
	//fprintf(f,"<FONT SIZE=\"1\" COLOR=\"#FFFFFF\">&nbsp Wersja tekstowa <A HREF=\"index_txt.htm\">\" dostepna tu. \"</a></B>");
	fprintf(f,"%s","<table BGCOLOR=\"#3366FF\" BORDER=\"1\" WIDTH=\"100%%\" CELLSPACING=\"0\" CELLPADDING=\"0\">\n");
	fprintf(f,"  <tr>\n");
	//Z0018, LT - wyciem cay fragment i przeniosem do funkcji
	List(AllUps, s_all, f, FALSE);		//lista z odnonikami do plikw graficznych
	//Z0018, LT - koniec
	//Z0010, LT - div nie moze tu byc - zamiast masy <br> robie dwa wiersze z roznym alignem
//	fprintf(f,"%s","<td VALIGN=\"TOP\" WIDTH=\"90%\" ALIGN=\"CENTER\">");
//	fprintf(f,"<FONT COLOR=\"#FFFFFF\"> <br>Oprogramowanie i projekt Fideltronik Krakw<br>");
//	fprintf(f,"<br><br><br><br><br><br><div ALIGN=\"RIGHT\">UPS Monitor 3.0 Unix wersja %s data %s</div><br>",ver,datReal);
//	fprintf(f,"<br>");
//	fprintf(f,"</FONT></td>");
	fprintf(f, "    <td VALIGN=\"TOP\" WIDTH=\"90%%\">\n");
	fprintf(f, "      <table BORDER=\"0\" WIDTH=\"100%%\" CELLSPACING=\"1\" CELLPADDING=\"20%%\">\n");
	fprintf(f, "        <tr ALIGN=\"CENTER\"><td><FONT COLOR=\"#FFFFFF\">Oprogramowanie i projekt Fideltronik Krakw</FONT></td></tr>\n");
	fprintf(f, "        <tr ALIGN=\"RIGHT\"><td><FONT COLOR=\"#FFFFFF\">UPS Monitor 3.0 Unix wersja %s data %s</FONT></td></tr>\n", ver, datReal);
	fprintf(f, "      </table>\n");
	fprintf(f, "    </td>\n");
	//Z0010, LT - koniec
	fprintf(f,"  </tr>\n");
	fprintf(f,"</table>\n");
	time_e=time(&time_e);
	fprintf(f,"<FONT SIZE=\"-1\" COLOR=\"#FFFFFF\">&nbsp Czas odczytu %s ",ctime(&time_e));
	fprintf(f,"</FONT>\n</body>\n");
	fprintf(f,"</html>\n");
}

//Z0018, LT - wyodrebniona funkcja do listy UPSw po lewej
void CDlgMain::List(CUPSConfig *AllUps, int s_all, FILE *f, BOOL txt)
{
	fprintf(f, "%s", "    <td VALIGN=\"TOP\" WIDTH=\"30%%\">\n");
	fprintf(f, "      <b><FONT SIZE=\"4\" COLOR=\"%s\" FACE=\"verdana, arial, helevica\">&nbsp Lista UPS-w</FONT></b><br>\n", txt? "BLACK": "#FFFFFF");
	fprintf(f, "%s", "      <table BORDER=\"0\" WIDTH=\"100%%\" CELLSPACING=\"1\" CELLPADDING=\"1\">\n");
	for(int j = 0; j <= s_all; j++)
	{ //lista z nazwami i stanami
		fprintf(f, "        <tr BGCOLOR=\"#CCFFFF\">\n");
		fprintf(f, "          <td>");
		fprintf(f, "<FONT SIZE=\"-1\">");
		if(txt)
			fprintf(f, "<A HREF=\"ups%dtxt.html\">UPS %d</a>", j+1, j+1);	//Z0010, LT - bylo: htm
		else
			fprintf(f, "<A HREF=\"ups%d.html\">UPS %d</a>", j+1, j+1);	//Z0010, LT - bylo: htm
		fprintf(f, "</FONT></td>\n");
		fprintf(f, "          <td>");
		fprintf(f, "<FONT SIZE=\"-1\">");
		fprintf(f, AllUps[j].m_Location);
		fprintf(f, "</FONT></td>\n");
		fprintf(f, "          <td>");
		switch(AllUps[j].m_Status)
		{
		case STATUS_NORMAL:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"GREEN\">");
			fprintf(f, "%s", STATUS_NORMAL_TEXT);
			break;
		case STATUS_BAT:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"RED\">");
			fprintf(f, "%s", STATUS_BAT_TEXT);
			break;
		case STATUS_BAT_LOW:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"RED\">");
			fprintf(f, "%s", STATUS_BAT_LOW_TEXT);
			break;
		case STATUS_AVR_UP:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"GREEN\">");
			fprintf(f, "%s", STATUS_AVR_UP_TEXT);
			break;
		case STATUS_AVR_DOWN:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"GREEN\">");
			fprintf(f, "%s", STATUS_AVR_DOWN_TEXT);
			break;
		case STATUS_OFF:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"#FFDDEE\">");
			fprintf(f, "%s", STATUS_OFF_TEXT);
			break;
		case STATUS_UPS_GOING_OFF:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"GREEN\">");
			fprintf(f, "%s", STATUS_UPS_GOING_OFF_TEXT);
			break;
		case STATUS_BYPASS:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"GREEN\">");
			fprintf(f, "%s", STATUS_BYPASS_TEXT);
			break;
		case STATUS_NO_COMMUNICATION:
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"BLACK\">");
			fprintf(f, STATUS_NO_COMMUNICATION_TEXT);
			break;
		default: // STATUS_GETTING_DATA
			fprintf(f, "<FONT SIZE=\"-1\" COLOR=\"GREEN\">");
			fprintf(f, "Czekaj");
			break;
		};//status switch
		fprintf(f, "</FONT></td>\n");
		fprintf(f, "        </tr>\n");
	}
	fprintf(f, "      </table>\n");
	fprintf(f, "    </td>\n");
}
//Z0018, LT - koniec

///////////////////////////////////////////////////////////
//Wtek gwny
void CDlgMain::DoWWW(CUPSConfig *AllUps, int Idx,int s_all)
{
	time_t time_e;
	int val=0;
//Z0018, LT - nieuzywany	char tab[255];	//,man[255],mod[255];
	CString man, mod;
	char fi[150];
	FILE *f;
	int res, k, i;	//Z0018, LT - j nieuzywane
	int hour,min,sec;
	int found=FALSE;
	char not_ava[25];

#define MAX_SCALE 25

	const int scale=MAX_SCALE;
	int max_VolIn=270;		//Z0011, LT - bylo 2500 i sie przepelniala dlugosc skali
#define VOL_IN_BAD 2000

	// Zmienne nadpisywane jest sa wpliku opisujacym upsa
	int max_VolBat=60;
	int max_OutCur=50; //20 2A
	int max_OutPow=1000;
	int max_OutVol=270;
	int max_Time=600; //10 min
	int  BAT_WEAK;
	int  BAT_LOW;
	int  CUR_WEAK;
	int  CUR_LOW;
	long  POW_WEAK;
	long  POW_LOW;

//	strcpy(man,AllUps[Idx].m_Manufacturer);
//	strcpy(mod,AllUps[Idx].m_Model);
	man = AllUps[Idx].m_Manufacturer;
	mod = AllUps[Idx].m_Model;
	memset(not_ava,0,sizeof(not_ava));
	strcpy(not_ava,STR_VAL_UNAVAILABLE);
	for(i=0;not_ava[i];i++)
		not_ava[i]=toupper(not_ava[i]);
	man.TrimLeft();
	man.TrimRight();
	man.MakeUpper();
	mod.TrimLeft();
	mod.TrimRight();
	mod.MakeUpper();
//	for(i=0;man[i];i++)
//		man[i]=toupper(man[i]);
//	for(i=0;mod[i];i++)
//		mod[i]=toupper(mod[i]);
//	TrimLeft(mod);
//	TrimRight(mod);
//	if(strlen(mod)!=0 || strlen(man)!=0)
	if(mod.GetLength() || man.GetLength())
	{
		for(i=UpsDlg.m_UPSModelsIdx-1;i>=0;i--)
		{
//			if((strncmp((char *)man,not_ava,6)==0
//			|| strcmp( (char *)man,(char *)UpsDlg.m_UPSModels[i].m_Manufacturer)==0) && strcmp((char *)mod,(char *)UpsDlg.m_UPSModels[i].m_Model)==0 )
			if((man == not_ava || man == UpsDlg.m_UPSModels[i].m_Manufacturer)
			&& mod == UpsDlg.m_UPSModels[i].m_Model)	//Z0011, LT - czemu do cholery tu bylo != ????
			{
				if(AllUps[Idx].m_MeterMaxBatVol!=UpsDlg.m_UPSModels[i].m_MaxBatVol)
					max_VolBat=UpsDlg.m_UPSModels[i].m_MaxBatVol;
				if(AllUps[Idx].m_MeterMaxCurrent!=UpsDlg.m_UPSModels[i].m_MaxCurrent)
					max_OutCur=UpsDlg.m_UPSModels[i].m_MaxCurrent;
				if(AllUps[Idx].m_MeterMaxPower!=UpsDlg.m_UPSModels[i].m_MaxPower)
					max_OutPow=UpsDlg.m_UPSModels[i].m_MaxPower;
				found=TRUE;
				break;
			} //if
		}//for
	}
	////////////////////////////////////////
	// Procentowe okreslenie zmiany kolorow
	// slupkow
	max_VolBat*=10;
	BAT_WEAK=(max_VolBat*95)/100;//10; //95%
	BAT_LOW=(max_VolBat*90)/100;//10; //90%
	CUR_WEAK=(max_OutCur*4)/10;//10; //80%
	CUR_LOW=(max_OutCur*2)/10;//10; //50%
	//Z0015, LT - max to jest nominalna pozorna, a nominalna czynna to jest ok. 60% pozornej
	POW_WEAK=(max_OutPow*60)/100;	//60% (czyli nominalna czynna)
	POW_LOW=(max_OutPow*54)/100;	//54% (czyli 90% nominalnej czynnej)
	//Z0015, LT - koniec

/////////////wersja tekstowa

	sprintf(fi, "%sups%dtxt.html", (char *)AllUps[Idx].m_pathLogWWW, Idx+1);	//Z0010, LT - bylo: htm
	if((f = fopen(fi,"w+")) == NULL )
	{
		if(__debug)
		{
			printf("Open file %s ERROR (4)\n",fi);
				perror("Open file :       ");
		}
		return; /* cant open log file ! */
	}

	fprintf(f,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n"
		"\"http://www.w3.org/TR/html4/loose.dtd\">\n");
	fprintf(f,"<html>");
	fprintf(f,"<head>\n");
	fprintf(f,"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-2\">\n");
	fprintf(f,"<meta name=\"Author\" content=\"Pawel Abramczuk\">\n");
	fprintf(f,"<meta name=\"GENERATOR\" content=\"Mozilla/4.78 [en] (Win98; U) [Netscape]\">\n");
	if(m_Cfg.m_refresh > 0)	//Z0004, LT
	//Z0010, LT - 1) brak else i pisze przypadkowy tab. 2) zmiana htm na html
//		sprintf(tab,"<META http-equiv=Refresh content=\"%d; url=ups%dtxt.htm\">\n", m_Cfg.m_refresh, Idx+1);	//Z0004, LT
//	fprintf(f,tab);
		fprintf(f,"<META http-equiv=\"Refresh\" content=\"%d; url=ups%dtxt.html\">\n", m_Cfg.m_refresh, Idx+1);
	fprintf(f, "<title>UPS Monitor 3.0 Unix wersja %s data %s</title>\n",ver,datReal);
	//Z0010, LT - beakowalo /head i body!
	fprintf(f,"</head>\n");
	fprintf(f,"<BODY text=\"navy\" LINK=\"red\" ALINK=\"red\" VLINK=\"red\">\n");
//Z0011, LT - przeniesione na dol	fprintf(f, "<FONT SIZE=\"2\" COLOR=\"BLACK\">&nbsp <A HREF=\"ups%d.html\">Wersja graficzna</a></FONT>\n", Idx+1);
	fprintf(f, "<table BORDER=\"1\" WIDTH=\"100%%\" CELLSPACING=\"1\" CELLPADDING=\"1\">\n");
//lewa str
	fprintf(f, "<tr>\n");
	//Z0018, LT - wyciem cay fragment i przeniosem do funkcji
	List(AllUps, s_all, f, TRUE);		//lista z odnonikami do plikw tekstowych
	//Z0018, LT - koniec
	fprintf(f, "  <td>\n");
// prawa strona parametry
	fprintf(f, "    <table BORDER=\"0\" WIDTH=\"100%%\" CELLSPACING=\"1\" CELLPADDING=\"1\">\n");
	fprintf(f, "      <tr>\n");
	fprintf(f, "        <td><FONT SIZE=\"5\"><B>UPS %d \"%s\"</B></FONT></td>\n", Idx+1, AllUps[Idx].m_Location);
	fprintf(f, "      </tr>\n");
//	fprintf(f,"<br><hr>\n");
	if(AllUps[Idx].m_Status != STATUS_NO_COMMUNICATION)
	{
		if(AllUps[Idx].m_InVol >= 0)
		{
			fprintf(f, "      <tr>\n");
			fprintf(f, "        <td>Napicie zasilania </td><td>%d,%dV</td>\n",
				AllUps[Idx].m_InVol/10, AllUps[Idx].m_InVol%10);
			fprintf(f, "      </tr>\n");
		}
		if(AllUps[Idx].m_BatVol >= 0)
		{
			fprintf(f, "      <tr>\n");
			fprintf(f, "        <td>Napicie baterii </td><td>%d,%d V</td>\n",
				AllUps[Idx].m_BatVol/10,AllUps[Idx].m_BatVol%10);
			fprintf(f, "      </tr>\n");
		}
		if(AllUps[Idx].m_OutCurrent >= 0)
		{
			fprintf(f, "      <tr>\n");
			fprintf(f, "        <td>Prd wyjciowy </td><td>%d,%d A</td>\n",
				AllUps[Idx].m_OutCurrent/10, AllUps[Idx].m_OutCurrent%10);
			fprintf(f, "      </tr>\n");
		}
		if(AllUps[Idx].m_OutPower >= 0)
		{
			fprintf(f, "      <tr>\n");
			fprintf(f, "        <td>Moc </td><td>%ld W</td>\n", AllUps[Idx].m_OutPower); //Z0015, LT - bylo / 10
			fprintf(f, "      </tr>\n");
		}
		if(AllUps[Idx].m_OutVol >= 0)
		{
			fprintf(f, "      <tr>\n");
			fprintf(f, "        <td>Napicie wyjciowe </td><td>%d,%d V</td>\n",
				AllUps[Idx].m_OutVol/10, AllUps[Idx].m_OutVol%10);
			fprintf(f, "      </tr>\n");
		}
		//Z0011, LT - w tekstowym nie bylo czasu pracy
		fprintf(f, "      <tr>\n");
		fprintf(f, "        <td>Czas pracy</td>\n");
		if(AllUps[Idx].m_UPSShutdownTime<=-1 && AllUps[Idx].m_SecToClose<=-1)
			fprintf(f, "        <td>%s<br>",STR_VAL_NOT_APPLY);
		else
			{
			int hour,min,sec;
			if(AllUps[Idx].m_SecToClose>=0)
			{
				hour=AllUps[Idx].m_SecToClose/3600;
				min=(AllUps[Idx].m_SecToClose-(hour*3600))/60;
				sec=AllUps[Idx].m_SecToClose-(hour*3600)-(min*60);
			}
			else
			{
				hour=AllUps[Idx].m_UPSShutdownTime/3600;
				min=(AllUps[Idx].m_UPSShutdownTime-(hour*3600))/60;
				sec=AllUps[Idx].m_UPSShutdownTime-(hour*3600)-(min*60);
			}
			fprintf(f, "        <td>%02d:%02d:%02d<br>",hour,min,sec);
		}
		fprintf(f, "</td>\n");
		fprintf(f, "      </tr>\n");
		//Z0011, LT - koniec
		if(AllUps[Idx].m_UPSStatus != UPS_JOINT_ACTIVE)	//Z0011, LT - w stykowym niedostepne
		{
			fprintf(f, "      <tr>\n");
			fprintf(f, "        <td>Producent </td><td>%s</td>\n",AllUps[Idx].m_Manufacturer);
			fprintf(f, "      </tr>\n");
			if(AllUps[Idx].m_SoftVer[0])	//niepusta
			{
				fprintf(f, "      <tr>\n");
				fprintf(f, "        <td>Model </td><td>%s wersja %s</td>\n",
					AllUps[Idx].m_Model, AllUps[Idx].m_SoftVer);
				fprintf(f, "      </tr>\n");
			}
			else
			{
				fprintf(f, "      <tr>\n");
				fprintf(f, "        <td>Model </td><td></td>\n");
				fprintf(f, "      </tr>\n");
			}
		}
		//Z0011, LT - zmieniona kolejnosc - lokalizacja idzie za status
//		fprintf(f, "      <tr>\n");
//		fprintf(f, "         <td>Lokalizacja </td><td>%s</td>\n", AllUps[Idx].m_Location);
//		fprintf(f, "      </tr>\n");
	}
// 2003.02.18 P.A.
// Obsluga Statusu
	if(AllUps[Idx].m_Status != STATUS_NO_COMMUNICATION)
	{
		//Z0011, LT - NIE! Nie zostawie tu takiego burdelu!
//		if(AllUps[Idx].m_UPSStatus!=-1)
//		{
//	//		fprintf(f,"<FONT SIZE=\"2\">");
//			fprintf(f, "      <tr>\n        <td>Status UPS-a</td><td>");
//			if(AllUps[Idx].m_UPSStatus==0)
//				fprintf(f, "Sprawny");
//			if((AllUps[Idx].m_UPSStatus>>8)==-UPS_BCHARGER_FAULT)
//				fprintf(f, "<FONT COLOR=\"RED\">CHARGER %d</FONT>", AllUps[Idx].m_UPSStatus);
//			if((AllUps[Idx].m_UPSStatus>>8)==-UPS_BATTERY_FAULT)
//				fprintf(f, "<FONT COLOR=\"RED\">BATTERY %d</FONT>", AllUps[Idx].m_UPSStatus);
//			if((AllUps[Idx].m_UPSStatus>>8)==-UPS_JOINT_ACTIVE)
//				fprintf(f, STR_VAL_NOT_APPLY);
//			fprintf(f, "</td>\n      </tr>\n");
//		}
		fprintf(f, "      <tr>\n");
		fprintf(f, "        <td>Status</td>\n");
		fprintf(f, "        <td>");
		switch(AllUps[Idx].m_UPSStatus)
		{
		case UPS_BCHARGER_FAULT:
			fprintf(f, "<FONT COLOR=\"red\">Awaria adowarki</FONT>");
			break;
		case UPS_BATTERY_FAULT:
			fprintf(f, "<FONT COLOR=\"red\">Baterie niesprawne</FONT>");
			break;
		case UPS_JOINT_ACTIVE:
			fprintf(f, "Interfejs stykowy");
			break;
		default:
			fprintf(f, "OK.");
			break;
		}
		fprintf(f, "</td>\n");
		fprintf(f, "      </tr>\n");
		//Z0011, LT - koniec
		//Z0011, LT - przeniesione z przed statusu
		//Z0018, LT - wycinam, bo jest juz w naglowku
//		fprintf(f, "      <tr>\n");
//		fprintf(f, "         <td>Lokalizacja </td><td>%s</td>\n", AllUps[Idx].m_Location);
//		fprintf(f, "      </tr>\n");
		//Z0018, LT - koniec
		//Z0011, LT - koniec
		if(AllUps[Idx].m_UPSStatus != UPS_JOINT_ACTIVE)	//Z0011, LT - w stykowym niedostepne
		{
			fprintf(f, "      <tr>\n        <td>Kondycja baterii</td><td><FONT COLOR=");
			switch(AllUps[Idx].m_BatCondition)
			{
			case 0:
				fprintf(f, "\"GREEN\">%s<br>", ODCZYT_SB_TEXT0);
				break;
			case 1:
				fprintf(f, "\"RED\">%s<br>", ODCZYT_SB_TEXT1);
				break;
			case 2:
				fprintf(f, "\"BLACK\">%s<br>", ODCZYT_SB_TEXT2);
				break;
			default:
				fprintf(f, "\"navy\">Niedostpne<br>");
				break;
			}
			fprintf(f, "</FONT></td>\n      </tr>\n");
		}
	}
	fprintf(f, "      <tr>\n        <td>");//<COLOR=\"BLACK\">
	fprintf(f, "Stan pracy</td><td>");
	fprintf(f,"<FONT ");//SIZE=\"4\" ");
	switch(AllUps[Idx].m_Status)
	 {
	case STATUS_NORMAL:
		fprintf(f,"COLOR=\"GREEN\"> %s ",STATUS_NORMAL_TEXT);
		break;
	case STATUS_BAT:
		fprintf(f,"COLOR=\"RED\"> %s",STATUS_BAT_TEXT);
		break;
	case STATUS_BAT_LOW:
		fprintf(f,"COLOR=\"RED\"> %s",STATUS_BAT_LOW_TEXT);
		break;
	case STATUS_AVR_UP:
		fprintf(f,"COLOR=\"GREEN\"> %s",STATUS_AVR_UP_TEXT);
		break;
	case STATUS_AVR_DOWN:
		fprintf(f,"COLOR=\"GREEN\"> %s",STATUS_AVR_DOWN_TEXT);
		break;
	case STATUS_OFF:
		fprintf(f,"COLOR=\"BLACK\"> %s",STATUS_OFF_TEXT);
		break;
	case STATUS_UPS_GOING_OFF:
		fprintf(f,"COLOR=\"GREEN\"> %s",STATUS_UPS_GOING_OFF_TEXT);
		break;
	case STATUS_BYPASS:
		fprintf(f,"COLOR=\"GREEN\"> %s",STATUS_BYPASS_TEXT);
		break;
	case STATUS_NO_COMMUNICATION:
		fprintf(f,"COLOR=\"BLACK\"> %s",STATUS_NO_COMMUNICATION_TEXT);
		break;
	default:
		fprintf(f,"COLOR=\"GREEN\"> %s","Brak");
		break;
	};
	fprintf(f,"</FONT></td>\n      </tr>\n    </table>\n");

/////////// koniec prawa
	fprintf(f, "  </td>\n</tr>\n");
	fprintf(f,"</table>\n");
	//Z0018, LT - dodaje tabelke,a w niej oprocz linka do graficznej, rowniez link do loga
	fprintf(f, "<table BORDER=\"0\" WIDTH=\"100%%\" CELLSPACING=\"1\" CELLPADDING=\"1\">\n");
	fprintf(f, "  <tr>\n");
	fprintf(f, "    <td><FONT SIZE=\"2\">&nbsp <A HREF=\"ups%d.html\">Wersja graficzna</a></FONT></td>\n", Idx+1);
	fprintf(f, "    <td><FONT SIZE=\"2\"><A HREF=\"ups%dlog.html\">Podgld pliku log</a></font></td>\n", Idx+1);
	fprintf(f, "  </tr>\n");
	fprintf(f,"</table>\n</body>\n</html>\n");
	res=fclose (f);
	if(res==-1)
		perror("FClose :");
///////////////////// index

// index.htm tylko gdy Idx=0
	if(Idx==0)
	{
		sprintf(fi,"%sindex.html",(char *)AllUps[Idx].m_pathLogWWW);	//Z0010, LT - bylo: htm
		 if((f = fopen(fi,"w")) == NULL )
		 {
				if(__debug)
				{
					printf("Open file %s ERROR (1)\n",fi);
				perror("Open file :       ");
				}
				return; /* cant open log file ! */
		 }
		 createListWWW(AllUps,Idx,s_all,f,"index");
		 res=fclose (f);
		 if(res==-1)
			perror("FClose :");
	}//if(Idx

////////////////// wersja graficzna
	sprintf(fi,"%sups%d.html",(char *)AllUps[Idx].m_pathLogWWW, Idx+1);	//Z0010, LT - bylo: htm
//printf("Plik %s %d\n",fi,Idx);
//delay(1000);
	if((f = fopen(fi,"w")) == NULL )
	{
		if(__debug)
		{
			printf("Open file %s ERROR (2)\n",fi);
				perror("Open file :       ");
		}
		return; /* cant open log file ! */
	}//if
//	res=flock((int)f,LOCK_EX);
//	if(res==-1)
//		perror("FLock EX :");

	//fprintf(f,"<html><head></head><body>\n");

	fprintf(f,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n"
		"\"http://www.w3.org/TR/html4/loose.dtd\">\n");
	fprintf(f,"<html>");
	fprintf(f,"<head>\n");
	fprintf(f,"  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-2\">\n");
	fprintf(f,"  <meta name=\"Author\" content=\"Pawel Abramczuk\">\n");
	fprintf(f,"  <meta name=\"GENERATOR\" content=\"Mozilla/4.78 [en] (Win98; U) [Netscape]\">\n");

	if(m_Cfg.m_refresh > 0)	//Z0004, LT
	//Z0010, LT - 1) brak else i pisze przypadkowy tab. 2) zmiana htm na html.
//		sprintf(tab,"<META http-equiv=Refresh content=\"%d; url=ups%d.htm\">", m_Cfg.m_refresh, Idx+1);	//Z0004, LT
		fprintf(f,"  <META http-equiv=\"Refresh\" content=\"%d; url=ups%d.html\">\n", m_Cfg.m_refresh, Idx+1);
//	fprintf(f,tab);
	fprintf(f,"  <title>UPS Monitor 3.0 Unix wersja %s data %s </title>\n",ver,datReal);
	fprintf(f,"</head>\n");
	fprintf(f,"<BODY BACKGROUND=\"images/tlo.gif\" text=\"navy\" LINK=\"red\" ALINK=\"red\" VLINK=\"red\">\n");	//Z0007, LT
	//fprintf(f,"<FONT SIZE=\"1\" COLOR=\"#FFFFFF\">&nbsp Wersja tekstowa <A HREF=\"index_txt.htm\">\" dostepna tu. \"</a></B>");
//Z0011, LT - przenosze na lepsze tlo	fprintf(f,"<FONT SIZE=\"2\" COLOR=\"#FFFFFF\">&nbsp <A HREF=\"ups%dtxt.html\">Wersja tekstowa</a></FONT>\n", Idx+1);	//Z0010, LT - bylo: htm
	//fprintf(f,"<A HREF=\"ups%dtxt.htm\">Ups %d</a>",j,j);

//	fprintf(f,"</head>");
//	fprintf(f,"<BODY BACKGROUND=\"tlo.gif\" text=\"navy\" LINK=\"red\" VLINK=\"red\">");
	fprintf(f, "<IMG SRC=\"images/logo.gif\" ALT=\"logo\"><br>\n");	//Z0007, LT
	fprintf(f, "<table BGCOLOR=\"#3366FF\" BORDER=\"1\" WIDTH=\"100%%\" CELLSPACING=\"0\" CELLPADDING=\"0\">\n");
	fprintf(f, "  <tr>\n");
	//Z0018, LT - wyciem cay fragment i przeniosem do funkcji
	List(AllUps, s_all, f, FALSE);		//lista z odnonikami do plikw graficznych
	//Z0018, LT - koniec
	fprintf(f, "    <td VALIGN=\"TOP\" WIDTH=\"90%%\">\n");
	//char tab[255];
//	sprintf(tab,"<b><FONT COLOR=\"#FFFFFF\" SIZE=\"4\" FACE=\"verdana, arial, helevica\">&nbsp Stan wybranego Ups-a<br> IP=%s<FONT SIZE=\"-1\"><br> Adres %s</b><br>",AllUps[Idx].m_IP,AllUps[Idx].m_Address);
	fprintf(f, "      <b><FONT COLOR=\"#FFFFFF\" SIZE=\"4\" FACE=\"verdana, arial, helevica\">&nbsp "
		"UPS %d \"%s\"<br></FONT>\n", Idx+1, AllUps[Idx].m_Location);
	fprintf(f, "<FONT COLOR=\"#FFFFFF\" SIZE=\"-1\"> IP=%s<br> Adres %s<br></FONT></b>\n",
		AllUps[Idx].m_IP, AllUps[Idx].m_Address);
//	fprintf(f,tab);
	fprintf(f, "<!-- tabelka z parametrami-->\n");
	fprintf(f, "      <table BORDER=\"0\" WIDTH=\"100%%\" CELLSPACING=\"0\" CELLPADDING=\"0\">\n");
	fprintf(f, "        <tr>\n");
	fprintf(f, "          <td VALIGN=\"TOP\" WIDTH=\"70%%\">\n");
	fprintf(f, "<!-- tabelka prawa czesc-->\n");
	fprintf(f, "            <table BORDER=\"0\" WIDTH=\"100%%\" CELLSPACING=\"0\" CELLPADDING=\"0\"  BGCOLOR=\"#CCCCCC\">\n");
	fprintf(f, "              <tr ALIGN=\"CENTER\" VALIGN=\"BOTTOM\">\n");
	fprintf(f, "                <td BACKGROUND=\"images/p_1.jpg\" WIDTH=\"17%%\" HEIGHT=\"150\">\n"); //Z0007, LT
	//AllUps[Idx].m_Status
//	fprintf(f,"<FONT SIZE=\"2\">");

/////////////////// napiecie wejsciowe
	if(AllUps[Idx].m_InVol!=0)
		val=(scale*AllUps[Idx].m_InVol)/max_VolIn;
	if(AllUps[Idx].m_InVol<0)
		fprintf(f, "                  <FONT SIZE=\"1\"><b>%s</b></FONT><br>",STR_VAL_UNAVAILABLE);
	else
	{
		fprintf(f, "                  <FONT SIZE=\"1\"><b>%d,%dV</b></FONT><br>\n",
			AllUps[Idx].m_InVol/10, AllUps[Idx].m_InVol%10);
		if(val>MAX_SCALE)
			val=MAX_SCALE;
		for(k=0;k<val;k++)
		{
			if(AllUps[Idx].m_InVol<VOL_IN_BAD)
				fprintf(f,"                  <IMG SRC=\"images/r.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
			else
				fprintf(f,"                  <IMG SRC=\"images/g.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
		}
	}
	fprintf(f, "                </td>\n");
/////////////////// akumulator
	val=0;
	if(AllUps[Idx].m_BatVol!=0)
		val=(scale*AllUps[Idx].m_BatVol)/max_VolBat;
	fprintf(f, "                <td BACKGROUND=\"images/p_3.jpg\" WIDTH=\"17%%\">\n");	//Z0007, LT
	if(AllUps[Idx].m_BatVol<0)
		fprintf(f,"                  <FONT SIZE=\"1\"><b>%s</b></FONT><br>\n",STR_VAL_UNAVAILABLE);
	else
	{
		fprintf(f,"                  <FONT SIZE=\"1\"><b>%d,%d V</b></FONT><br>\n", AllUps[Idx].m_BatVol/10, AllUps[Idx].m_BatVol%10);
		if(val>MAX_SCALE)
			val=MAX_SCALE;
		for(k=0;k<val;k++)
		{
			if(AllUps[Idx].m_BatVol >= BAT_WEAK)
			{
				fprintf(f,"                  <IMG SRC=\"images/g.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
			}
			else
			{
				if((AllUps[Idx].m_BatVol < BAT_WEAK) && (AllUps[Idx].m_BatVol >= BAT_LOW))
					fprintf(f,"                  <IMG SRC=\"images/y.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
				else
					fprintf(f,"                  <IMG SRC=\"images/r.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
			}
		}
	}
	fprintf(f, "                </td>\n");
///////////////////////// prad wy
	val=0;
	if(AllUps[Idx].m_OutCurrent!=0)
		val=(scale*AllUps[Idx].m_OutCurrent)/max_OutCur;
	fprintf(f, "                <td BACKGROUND=\"images/p_1.jpg\" WIDTH=\"17%%\">\n");	//Z0007, LT
	if(AllUps[Idx].m_OutCurrent<0)
		fprintf(f,"                  <FONT SIZE=\"1\"><b>%s</b></FONT><br>\n",STR_VAL_UNAVAILABLE);
	else
	{
		if(val>MAX_SCALE) val=MAX_SCALE;
			fprintf(f, "                  <FONT SIZE=\"1\"><b>%d,%d A</b></FONT><br>\n",
				AllUps[Idx].m_OutCurrent/10, AllUps[Idx].m_OutCurrent%10);
		for(k=0;k<val;k++)
		{
			if(AllUps[Idx].m_OutCurrent <= CUR_LOW)
			{
				fprintf(f,"                  <IMG SRC=\"images/g.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
			}
			else
			{
				if(AllUps[Idx].m_OutCurrent <= CUR_WEAK)
					fprintf(f,"                  <IMG SRC=\"images/y.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
				else
					fprintf(f,"                  <IMG SRC=\"images/r.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
			}
		}
	}
	fprintf(f, "                </td>\n");
//////////////////////// moc
	fprintf(f, "                <td BACKGROUND=\"images/p_3.jpg\" WIDTH=\"17%%\">\n");	//Z0007, LT
	//fprintf(f,"%s ............ %d,%d [W]\n<br>","Moc wyj ",UPS->m_OutPower/10,UPS->m_OutPower%10);
	val=0;
	if(AllUps[Idx].m_OutPower!=0)
		val=(scale*AllUps[Idx].m_OutPower)/max_OutPow;
	if(AllUps[Idx].m_OutPower<0)
		fprintf(f, "                  <FONT SIZE=\"1\"><b>%s</b></FONT><br>\n",STR_VAL_UNAVAILABLE);
	else
	{
		fprintf(f, "                  <FONT SIZE=\"1\"><b>%ld W</b></FONT><br>\n",AllUps[Idx].m_OutPower);
		if(val>MAX_SCALE)
			val=MAX_SCALE;
		for(k=0;k<val;k++)
		{
			if(AllUps[Idx].m_OutPower <= POW_LOW)
			{
				fprintf(f,"                  <IMG SRC=\"images/g.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
			}
			else
			{
				if(AllUps[Idx].m_OutPower <= POW_WEAK)
					fprintf(f, "                  <IMG SRC=\"images/y.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
				else
					fprintf(f, "                  <IMG SRC=\"images/r.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
			}
		}
	}
	fprintf(f, "                </td>\n");
/////////////////////////napiecie wyjsciowe
	//fprintf(f,"%s ....... %d,%d [V]\n<br>","Napiecie wyj ",UPS->m_OutVol/10,UPS->m_OutVol%10);
	val=0;
	if(AllUps[Idx].m_OutVol!=0)
		val=(scale*AllUps[Idx].m_OutVol)/max_OutVol;
	fprintf(f, "                <td BACKGROUND=\"images/p_1.jpg\" WIDTH=\"17%%\">\n");	//Z0007, LT
	if(AllUps[Idx].m_OutVol<0)
		fprintf(f, "                  <FONT SIZE=\"1\"><b>%s</b></FONT><br>\n",STR_VAL_UNAVAILABLE);
	else
	{
		fprintf(f, "                  <FONT SIZE=\"1\"><b>%d,%d V</b></FONT><br>\n", AllUps[Idx].m_OutVol/10, AllUps[Idx].m_OutVol%10);
		if(val>MAX_SCALE)
			val=MAX_SCALE;
		for(k=0;k<val;k++)
			fprintf(f, "                  <IMG SRC=\"images/g.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
	}
	fprintf(f, "                </td>\n");
/////////////////// obcazenie brak
//fprintf(f,"%s ......... %d,%d [V]\n<br>","Obciazenie ",UPS->m_OutLoad/10,UPS->m_OutLoad%10);
////////////////// czas pracy
	val=0;
	//if(AllUps[Idx].m_UPSShutdownTime!=0)
	//val=(scale*AllUps[Idx].m_UPSShutdownTime)/max_Time;

	//AllUps[Idx].m_UPSShutdownTime
	//if(AllUps[Idx].m_UPSShutdownTime>0)
	if(AllUps[Idx].m_SecToClose>=0)
		val=(scale*AllUps[Idx].m_SecToClose)/max_Time;
	fprintf(f, "                <td BACKGROUND=\"images/p_3.jpg\" WIDTH=\"17%%\">\n");	//Z0007, LT

	if(AllUps[Idx].m_UPSShutdownTime<=-1 && AllUps[Idx].m_SecToClose<=-1)
		fprintf(f, "                  <FONT SIZE=\"1\"><b>%s</b></FONT><br>\n", STR_VAL_NOT_APPLY);
	else
	{
		if(AllUps[Idx].m_SecToClose>=0)
		{
			hour=AllUps[Idx].m_SecToClose/3600;
			min=(AllUps[Idx].m_SecToClose-(hour*3600))/60;
			sec=AllUps[Idx].m_SecToClose-(hour*3600)-(min*60);
		}
		else
		{
			hour=AllUps[Idx].m_UPSShutdownTime/3600;
			min=(AllUps[Idx].m_UPSShutdownTime-(hour*3600))/60;
			sec=AllUps[Idx].m_UPSShutdownTime-(hour*3600)-(min*60);
		}
		fprintf(f, "                  <FONT SIZE=\"1\"><b>%02d:%02d:%02d<br></b></FONT><br>\n",hour,min,sec);
		if(val>MAX_SCALE)
			val=MAX_SCALE;
		for(k=0;k<val;k++)
			fprintf(f, "                  <IMG SRC=\"images/r.jpg\" ALT=\"\"><br>\n");	//Z0007, LT
	}
	fprintf(f, "                </td>\n");

	fprintf(f, "              </tr>\n");
	fprintf(f, "              <tr ALIGN=\"CENTER\" VALIGN=\"MIDDLE\" BGCOLOR=\"#FFFEEE\">\n");
	fprintf(f, "                <td><FONT SIZE=\"1\">Napicie zasil.</FONT></td>\n");
	fprintf(f, "                <td><FONT SIZE=\"1\">Napicie akum.</FONT></td>\n");
	fprintf(f, "                <td><FONT SIZE=\"1\">Prd wyjc.</FONT></td>\n");
	fprintf(f, "                <td><FONT SIZE=\"1\">Moc wyjc.</FONT></td>\n");
	fprintf(f, "                <td><FONT SIZE=\"1\">Napicie wyjc.</FONT></td>\n");
	fprintf(f, "                <td><FONT SIZE=\"1\">Czas pracy.</FONT></td>\n");
	fprintf(f, "              </tr>\n");
	fprintf(f, "            </table>\n");
	fprintf(f, "          </td>\n");
	fprintf(f, "        </tr>\n");
	fprintf(f, "      </table>\n");

	fprintf(f, "<!-- Opis UPS -->\n");
	fprintf(f, "<!-- tabelka lewa czesc-->\n");
//	fprintf(f, "      <table BORDER=\"0\" COLS=\"2\" WIDTH=\"100%\" CELLSPACING=\"1\" CELLPADDING=\"1\">\n");	//Z0010, LT - brak "", tymcz po co bylo COLS?
	fprintf(f, "      <table BORDER=\"0\" WIDTH=\"100%%\" CELLSPACING=\"1\" CELLPADDING=\"1\">\n");
	//Z0018, LT - wiksza cz parametrw bdzie tylko jak jest komunikacja
	if(AllUps[Idx].m_Status != STATUS_NO_COMMUNICATION)
	{
		if(AllUps[Idx].m_UPSStatus != UPS_JOINT_ACTIVE)	//Z0011, LT - w stykowym niedostepne
		{
			fprintf(f, "        <tr BGCOLOR=\"#CCFFFF\">\n");
			fprintf(f, "          <td WIDTH=\"30%%\"><FONT SIZE=\"2\">Producent</FONT></td>\n");
			fprintf(f, "          <td><FONT SIZE=\"2\">%s</FONT></td>\n", AllUps[Idx].m_Manufacturer);
			fprintf(f, "        </tr>\n");

			fprintf(f, "        <tr BGCOLOR=\"#CCFFFF\">\n");
			fprintf(f, "          <td><FONT SIZE=\"2\">Model</FONT></td>\n");
			fprintf(f, "          <td><FONT SIZE=\"2\">%s %s %s</FONT></td>\n",
				AllUps[Idx].m_Model, AllUps[Idx].m_SoftVer[0]? "wersja":"", AllUps[Idx].m_SoftVer);
			fprintf(f, "        </tr>\n");
		}
		//Z0018, LT - wycinam bardzo stary zakomentowany fragment
		fprintf(f, "        <tr BGCOLOR=\"#CCFFFF\">\n");
		fprintf(f, "          <td><FONT SIZE=\"2\">Status</FONT></td>\n");
		fprintf(f, "          <td><FONT SIZE=\"2\"");
		switch(AllUps[Idx].m_UPSStatus)
		{
		case UPS_BCHARGER_FAULT:
			fprintf(f, "COLOR=\"red\">Awaria adowarki");
			break;
		case UPS_BATTERY_FAULT:
			fprintf(f, "COLOR=\"red\">Baterie niesprawne");
			break;
		case UPS_JOINT_ACTIVE:
			fprintf(f, ">Interfejs stykowy");
			break;
		default:
			fprintf(f, ">OK.");
			break;
		}
		fprintf(f, "</FONT></td>\n");
		fprintf(f, "        </tr>\n");
		//Z0011, LT - koniec

		//Z0018, LT - wycinam, bo jest juz w naglowku
	//	fprintf(f, "        <tr BGCOLOR=\"#CCFFFF\">\n");
	//	fprintf(f, "          <td><FONT SIZE=\"2\">Lokalizacja</FONT></td>\n");
	//	fprintf(f, "          <td><FONT SIZE=\"2\">%s</FONT></td>\n", AllUps[Idx].m_Location);
	//	fprintf(f, "        </tr>\n");
		//Z0018, LT - koniec
	/* Z0011, LT - nie ma potrzeby, bo jest slupek
		fprintf(f, "        <tr BGCOLOR=\"#CCFFFF\">\n");
		fprintf(f, "          <td><FONT SIZE=\"2\">Czas pracy</FONT></td>\n");
		if(AllUps[Idx].m_UPSShutdownTime<=-1 && AllUps[Idx].m_SecToClose<=-1)
			fprintf(f, "          <td><FONT SIZE=\"2\">%s<br>",STR_VAL_NOT_APPLY);
		else
		{
			int hour,min,sec;
			if(AllUps[Idx].m_SecToClose>=0)
			{
				hour=AllUps[Idx].m_SecToClose/3600;
				min=(AllUps[Idx].m_SecToClose-(hour*3600))/60;
				sec=AllUps[Idx].m_SecToClose-(hour*3600)-(min*60);
			}
			else
			{
				hour=AllUps[Idx].m_UPSShutdownTime/3600;
				min=(AllUps[Idx].m_UPSShutdownTime-(hour*3600))/60;
				sec=AllUps[Idx].m_UPSShutdownTime-(hour*3600)-(min*60);
			}

			//int hour=AllUps[Idx].m_UPSShutdownTime/3600;
			//int min=(AllUps[Idx].m_UPSShutdownTime-(hour*3600))/60;
			//int sec=AllUps[Idx].m_UPSShutdownTime-(hour*3600)-(min*60);
			//fprintf(f,"<td><FONT SIZE=\"-1\"><b>%02d:%02d:%02d<br>[sek]<br>",hour,min,sec);
			fprintf(f, "          <td><FONT SIZE=\"2\">%02d:%02d:%02d<br>",hour,min,sec);
		}
		fprintf(f, "</FONT></td>\n");
		fprintf(f, "        </tr>\n");
	Z0011, LT - koniec */
		if(AllUps[Idx].m_UPSStatus != UPS_JOINT_ACTIVE)	//Z0011, LT - w stykowym niedostepne
		{
			fprintf(f, "        <tr BGCOLOR=\"#CCFFFF\">\n");
			fprintf(f, "          <td><FONT SIZE=\"2\">Kondycja baterii</FONT></td>\n");
			//fprintf(f,"<td><FONT SIZE=\"2\">-1</td>");
			switch(AllUps[Idx].m_BatCondition)
			{
			case 0:
				fprintf(f, "          <td><FONT SIZE=\"2\" COLOR=\"GREEN\">%s</FONT></td>\n",ODCZYT_SB_TEXT0);
				break;
			case 1:
				fprintf(f, "          <td><FONT SIZE=\"2\" COLOR=\"RED\">%s</FONT></td>\n",ODCZYT_SB_TEXT1);
				break;
			case 2:
				fprintf(f, "          <td><FONT SIZE=\"2\" COLOR=\"BLACK\">%s</FONT></td>\n",ODCZYT_SB_TEXT2);
				break;
			default:
				fprintf(f, "          <td><FONT SIZE=\"2\">Niedostpne</FONT></td>\n");
				break;
			}
			fprintf(f, "        </tr>\n");
		}
	}	//Z0018, LT - koniec bloku wykonywanego tylko jak jest komunikacja
	fprintf(f, "        <tr BGCOLOR=\"#CCFFFF\">\n");
	fprintf(f, "          <td><FONT SIZE=\"2\">Stan pracy</FONT></td>\n");
	fprintf(f, "          <td>");
	switch(AllUps[Idx].m_Status)
	{
	case STATUS_NORMAL:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"GREEN\">");
		fprintf(f,STATUS_NORMAL_TEXT);
		break;
	case STATUS_BAT:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"RED\">");
		fprintf(f,STATUS_BAT_TEXT);
		break;
	case STATUS_BAT_LOW:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"RED\">");
		fprintf(f,STATUS_BAT_LOW_TEXT);
		break;
	case STATUS_AVR_UP:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"GREEN\">");
		fprintf(f,STATUS_AVR_UP_TEXT);
		break;
	case STATUS_AVR_DOWN:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"GREEN\">");
		fprintf(f,STATUS_AVR_DOWN_TEXT);
		break;
	case STATUS_OFF:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"BLACK\">");
		fprintf(f,STATUS_OFF_TEXT);
		break;
	case STATUS_UPS_GOING_OFF:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"GREEN\">");
		fprintf(f,STATUS_UPS_GOING_OFF_TEXT);
		break;
	case STATUS_BYPASS:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"GREEN\">");
		fprintf(f,STATUS_BYPASS_TEXT);
		break;
	case STATUS_NO_COMMUNICATION:
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"BLACK\">");
		fprintf(f,STATUS_NO_COMMUNICATION_TEXT);
		break;
	default: // STATUS_GETTING_DATA
		fprintf(f,"<FONT SIZE=\"2\" COLOR=\"GREEN\">");
		fprintf(f,"Czekaj");
		break;
	};
	//fprintf(f,"<td><FONT SIZE=\"4\" COLOR=\"#FF33AA\">Praca na bateriach</td>");
	fprintf(f, "</FONT></td>\n");
	fprintf(f, "        </tr>\n");
	fprintf(f, "      </table>\n");

//	fprintf(f,"<FONT SIZE=\"-1\" COLOR=\"#FFFFFF\">&nbsp <B><A HREF=\"ups%dlog.htm\">Podgld pliku log</a></B>",Idx);
//	time_e=time(&time_e);
//	fprintf(f,"<FONT SIZE=\"-1\" COLOR=\"#FFFFFF\">&nbsp Czas odczytu %s ",ctime(&time_e));
	fprintf(f, "<!-- tabelka z parametrami koniec-->\n");

	fprintf(f, "    </td>\n");
	fprintf(f, "<!-- Opis UPS koniec -->\n");

	fprintf(f, "  </tr>\n");
	//Z0011, LT - przenosze tu linki
	fprintf(f, "  <tr BGCOLOR=\"#CCFFFF\">\n");
	fprintf(f, "    <td><FONT SIZE=\"2\">");
	fprintf(f, "&nbsp <A HREF=\"ups%dtxt.html\">Wersja tekstowa</a>", Idx+1);	//Z0010, LT - bylo: htm
	fprintf(f, "</FONT></td>\n");
	fprintf(f, "    <td><FONT SIZE=\"2\">");
	fprintf(f, "&nbsp <A HREF=\"ups%dlog.html\">Podgld pliku log</a>", Idx+1);	//Z0010, LT - bylo: htm
	fprintf(f, "</FONT></td>\n");
	fprintf(f, "  </tr>\n");
	//Z0011, LT - koniec
	fprintf(f, "</table>\n");

	time_e=time(&time_e);
	fprintf(f, "<table WIDTH=\"100%%\">\n  <tr>\n");
	fprintf(f, "    <td><FONT SIZE=\"-1\" COLOR=\"#FFFFFF\">&nbsp Czas odczytu %s </FONT></td>\n",ctime(&time_e));
//Z0011, LT - przeniesione na lepsze tlo	fprintf(f, "    <td ALIGN=\"RIGHT\"><FONT SIZE=\"-1\" COLOR=\"#FFFFFF\">&nbsp <A HREF=\"ups%dlog.html\">Podgld pliku log</a></FONT></td>\n", Idx+1);	//Z0010, LT - bylo: htm
	fprintf(f, "  </tr>\n</table>\n");
	fprintf(f,"</body>\n");
	fprintf(f,"</html>\n");
	//////////////////

	//res=flock((int)f,LOCK_UN);//LOCK_UN
	//if(res!=-1)
	res=fclose (f);
	if(res==-1)
		perror("FClose :");
}//dowww
