///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/09 11:31:07 $
//         $Locker:  $
//         $Revision: 1.3 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Generowanie plikw htm
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: html.h,v $
// Revision 1.3  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#define ODCZYT_MODEL               0   // musi byc numerowane kolejno
#define ODCZYT_PRODUCENT           1   // rozpoczynajac od 0
#define ODCZYT_LOKALIZACJA         2
#define ODCZYT_CZAS_PRACY          3
#define ODCZYT_NAPIECIE_ZASILANIA  4
#define ODCZYT_MOC_WYJSCIOWA       5
#define ODCZYT_PRAD_WYJSCIOWY      6
#define ODCZYT_NAPIECIE_WYJSCIOWE  7
#define ODCZYT_AKUMULATOR          8
#define ODCZYT_STAN_ZASILACZA      9
#define ODCZYT_OBCIAZENIE          10
#define ODCZYT_STAN_BATERII        11
#define ODCZYT_WERSJA_UPS          12
#define ODCZYT_WYLACZONY           13  // musi byc jako ostatnia pozycja
// dla kazdej powyzszej pozycji sa zdefiniowane nastepujace stale:
// ..._TEXT          - opis pozycji
// ..._TYPE          - typ pozycji (jedna ze stalych TYPE_)
// ..._UNIT          - jednostka (tylko gdy _TYPE!=TYPE_TEXT)
// dla ODCZYT_MODEL
#define ODCZYT_M_TEXT              "Model"
#define ODCZYT_M_TYPE              TYPE_TEXT
#define ODCZYT_M_UNIT              ""
// dla ODCZYT_PRODUCENT
#define ODCZYT_P_TEXT              "Producent"
#define ODCZYT_P_TYPE              TYPE_TEXT
#define ODCZYT_P_UNIT              ""
// dla ODCZYT_LOKALIZACJA
#define ODCZYT_L_TEXT              "Lokalizacja"
#define ODCZYT_L_TYPE              TYPE_TEXT
#define ODCZYT_L_UNIT              ""
// dla ODCZYT_CZAS_PRACY
#define ODCZYT_CP_TEXT             "Czas pracy"
#define ODCZYT_CP_TYPE             TYPE_TEXT
#define ODCZYT_CP_UNIT             ""
// dla ODCZYT_NAPIECIE_ZASILANIA
#define ODCZYT_NZ_TEXT             "Napicie zasilania"
#define ODCZYT_NZ_TYPE             TYPE_FLOAT
#define ODCZYT_NZ_UNIT             "[V]"
// dla ODCZYT_MOC_WYJSCIOWA
#define ODCZYT_MW_TEXT             "Moc wyjciowa"
#define ODCZYT_MW_TYPE             TYPE_INT
#define ODCZYT_MW_UNIT             "[W]"
// dla ODCZYT_PRAD_WYJSCIOWY
#define ODCZYT_PW_TEXT             "Prd wyjciowy"
#define ODCZYT_PW_TYPE             TYPE_FLOAT
#define ODCZYT_PW_UNIT             "[A]"
// dla ODCZYT_NAPIECIE_WYJSCIOWE
#define ODCZYT_NW_TEXT             "Napicie wyjciowe"
#define ODCZYT_NW_TYPE             TYPE_FLOAT
#define ODCZYT_NW_UNIT             "[V]"
// dla ODCZYT_AKUMULATOR
#define ODCZYT_A_TEXT              "Akumulator"
#define ODCZYT_A_TYPE              TYPE_FLOAT
#define ODCZYT_A_UNIT              "[V]"
// dla ODCZYT_STAN_ZASILACZA
#define ODCZYT_SZ_TEXT             "Stan zasilacza"
#define ODCZYT_SZ_TYPE             TYPE_TEXT
#define ODCZYT_SZ_UNIT             ""
#define ODCZYT_SZ_TEXT0            "Stan normalny"      // 0 - normal
#define ODCZYT_SZ_TEXT1            "Awaria zasilania"   // 1 - on battery
#define ODCZYT_SZ_TEXT2            "Stan normalny"      // 2 - on bypass
#define ODCZYT_SZ_TEXT3            "AVR grny"          // 3 - reducing
#define ODCZYT_SZ_TEXT4            "AVR dolny"          // 4 - boosting
#define ODCZYT_SZ_TEXT5            "Wyczony"          // 5 - other
// dla ODCZYT_OBCIAZENIE
#define ODCZYT_O_TEXT              "Obcienie"
#define ODCZYT_O_TYPE              TYPE_INT
#define ODCZYT_O_UNIT              "[%]"
// dla ODCZYT_STAN_BATERII
#define ODCZYT_SB_TEXT             "Stan baterii"
#define ODCZYT_SB_TYPE             TYPE_TEXT
#define ODCZYT_SB_UNIT             ""
#define ODCZYT_SB_TEXT0            "W normie"           // 0 - good
#define ODCZYT_SB_TEXT1            "Sabe"              // 1 - weak
#define ODCZYT_SB_TEXT2            "Do wymiany"         // 2 - replace
// dla ODCZYT_WERSJA_UPS
#define ODCZYT_WU_TEXT             "Wersja UPS"
#define ODCZYT_WU_TYPE             TYPE_TEXT
#define ODCZYT_WU_UNIT             ""
// dla ODCZYT_WYLACZONY
#define ODCZYT_W_TEXT              "Wyczony"
#define ODCZYT_W_TYPE              TYPE_TEXT
#define ODCZYT_W_UNIT              ""

#define STATUS_NORMAL_COLOR           RGB(0,200,0)
#define STATUS_BAT_COLOR              RGB(250,250,0)
#define STATUS_BAT_LOW_COLOR          RGB(255,0,0)
#define STATUS_AVR_UP_COLOR           RGB(220,120,15)
#define STATUS_AVR_DOWN_COLOR         RGB(220,120,15)
#define STATUS_OFF_COLOR              RGB(0,0,0)
#define STATUS_UPS_GOING_OFF_COLOR    RGB(0,0,0)
#define STATUS_NO_COMMUNICATION_COLOR RGB(0,0,200)
#define STATUS_GETTING_DATA_COLOR     RGB(0,0,0)
#define STATUS_NORMAL_TEXT            "Stan normalny"
#define STATUS_BAT_TEXT               "Awaria zasilania"
#define STATUS_BAT_LOW_TEXT           "Baterie niskie"
#define STATUS_AVR_UP_TEXT            "AVR grny"
#define STATUS_AVR_DOWN_TEXT          "AVR dolny"
#define STATUS_OFF_TEXT               "Wyczony"
#define STATUS_UPS_GOING_OFF_TEXT     "Wyczanie zasilacza"
#define STATUS_BYPASS_TEXT            "Bypass"
#define STATUS_NO_COMMUNICATION_TEXT  "Brak komunikacji"
#define STATUS_GETTING_DATA_TEXT      ""

#define STATUS_LOG_BAT_COLOR           RGB(200,200,0)
#define STATUS_UPS_LIST_BAT_COLOR      RGB(200,200,0)

/////////////////////////////////////////////////////////////////////////////
