///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/19 12:09:58 $
//         $Locker:  $
//         $Revision: 1.15 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Definicja klasy gwnej programu
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: main.h,v $
// Revision 1.15  2004/07/19 12:09:58  ltokarski
// Z0018 - bdne wyswietlanie stron przy pustej lokalizacji, inne poprawki w htmlach
//
// Revision 1.14  2004/07/05 11:20:56  ltokarski
// Z0012 - wyswietlanie statusu na zadanie
//
// Revision 1.13  2004/06/30 16:43:16  ltokarski
// Z0009 - uporzadkowanie pamieci dzielonej
//
// Revision 1.12  2004/06/29 16:16:09  ltokarski
// Z0008 - przechodzenie do tla dopiero po zainicjowaniu i zwracanie kodu bledu
//
// Revision 1.11  2004/06/23 08:57:00  ltokarski
// Z0003 - czytanie pliku options.cfg
//
// Revision 1.9  2004/06/09 14:16:29  ltokarski
// Z0002 - zwracanie bdw do KillAll
//
// Revision 1.8  2004/06/09 14:13:34  ltokarski
// Z0001 - warunkowe kompilowanie curses.h i WINDOW
//
// Revision 1.7  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

//Z0001, LT
#ifdef NCURRSESS
#include <curses.h>
#endif

//#define COleDateTime time_t

class CDlgMain
{
public:
	//BOOL Add(CUPSConfig *UPS, BYTE Color, LPCTSTR Str/*, CColorListBox *List*/);
	void OnRead(LPCTSTR Addr, UINT Port, BYTE *Buff, int Len);
	int getData(void);
	int ReadConfig();
//	int ReadGlobalConfig(CString *cfg, UINT *sPortIP, UINT *cPortIP, CString *log, CString *logWWW, UINT *refresh); //Z0003, LT
	int ReadGlobalConfig(CUPSMonConfig *cfg);	//Z0009, LT - upraszczam, bo sie zrobilo za duzo parametrow
	void ReadUPSModelsConfig();
	int DlgMainInit(int argc,char *argv[]);
	int  OnUPSMonStart(int ReadConfigOK);
	void OnSendMailEnd(BYTE ErrorCode, DWORD UPSId);
	// grafika
	void initUpsPanel(int idx);
	void putLine(char *str);
	int OnTimer(UINT nIDEvent);
	int OnTimerOff(int i);
	int OnTimerTask(int i);
	void KillAll(int res);      //Z0002, LT
	void StopUPSMon();
	void printStatus();		//Z0012, LT
	//void OnSendMailEnd(BYTE ErrorCode, DWORD UPSId);
//protected:
	//virtual void DoDataExchange(CDataExchange* pDX);   // DDX/DDV support
	CDlgMain();
	~CDlgMain();
	pthread_t mythread;
	pthread_t mythreadTask;
//	BOOL Restart; //restart

	time_t m_clock();

	CNetDatagram m_Net;

protected:
	int SizeAllUps;

	//void *ptr_onTime(void *);

//Z0001, LT
#ifdef NCURRSESS
	WINDOW *list,*params,*win;
	WINDOW *icon;

	WINDOW *ti;
#endif

#define MAX_UPS 25
	CUPSConfig  m_AllUPS[MAX_UPS]; // konfiguracja 1 ups
#define MAX_TASKS 25
	CTaskConfig m_Tasks[MAX_TASKS];
	int m_TasksGetSize;
//CTypedPtrArray<CObArray,CTaskConfig*> m_Tasks;

	CSharedMemory m_SharedMem;
	CSMTPClient m_Mail;

	CUPSMonConfig m_Cfg;
	CUPSModelConfig m_UPSModels[50];
	int m_UPSModelsIdx;
	//CTypedPtrArray<CObArray,CUPSConfig*> m_AllUPS;
	CUPSLog m_Log;

	BOOL m_IsLocalUPS;        // ==TRUE gdy na liscie monitorowanych zasilaczy
	                         // znajduje sie lokalny UPS


	BOOL 	m_TaskInProgress;    // ==TRUE gdy aktualnie wykonywane jest zadanie
	BYTE 	m_TaskType;          // zadanie do wykonania (jedna ze stalych TASK_)
	long 	m_TaskTurnOnDelay;   // istotne tylko gdy m_Task==TASK_RESTART
	time_t	m_TaskDate;  // data i czas wykonania zadania


	//afx_msg LRESULT OnGetHostByName(WPARAM wParam, LPARAM lParam);
	//void SetupMenu();
	//void ShowTab(int Idx);

	void UpdateUPSStatus(CUPSConfig *UPS);
	//void FillActiveUPSList();

	int  GetSize(void);

	int convertDateTask(char *t, time_t *m_DateTime, int &hour, int &min);
	void SetupMenu();
	void ChangeIconOnTaskBar(int error);
	void SetupOdczyty(int CurrPos);
	void SetOdczytyType(CUPSConfig *UPS);
	void SetOdczytyValue(CUPSConfig *UPS);
	void GetOdczytyValueText(char *Txt, int Pos, CUPSConfig *UPS);

	BYTE GetLocalUPSCloseSysFlag();
	time_t GetCurrentTime();
	//void WriteConfig();
	void SelectFirstTask();
	BOOL GetTaskDate(CTaskConfig *Task, time_t &Now, time_t &TaskDate);
	void CheckLocalUPS(BOOL FirstCheck);
	int AnalizeNormalPacket(BYTE *Buff, int Len, CUPSConfig *UPS, int Idx);
	void DoWWW(CUPSConfig *AllUps, int Idx,int s_all);
	void createListWWW(CUPSConfig *AllUps, int Idx,int s_all,FILE *f,char *fileRefresh);
	void CDlgMain::List(CUPSConfig *AllUps, int s_all, FILE *f, BOOL txt);		//Z0018, LT
	BOOL AnalizeDoTaskPacket(BYTE *Buff, int Len, CUPSConfig *UPS, int Idx);
	void DoTask();
	int AnalizeTurnOffPacket(BYTE *Buff, int Len, CUPSConfig *UPS, int Idx);
	BOOL ChangeStatus(CUPSConfig *UPS, BYTE NewStatus);
	int DoAction(CUPSConfig *UPS, int Idx);
	void SetCurrEvent(CUPSConfig *UPS, int CurrEvent);

	void removeSpace(char *t);
	void removeEndWhite(char *t);
	void initNCurses(void);
	void showList(int idx);
	void showParam(int idx);
	//afx_msg LRESULT OnMailGetHostByName(WPARAM wParam, LPARAM lParam);
	//void OnEndSession(BOOL Ending);
	int CloseSystem(BYTE Force);
	//void StopUPSMon();
	void UpdateScreen(CUPSConfig *UPS, int Idx, BOOL StatusChanged);
public:
	//Z0008, LT - nowe funkcje do pamieci dzielonej
	void InitSharedMem();
	int GetExitCode() { int i; m_SharedMem.Read((unsigned char*)&i, sizeof(int), SHARED_MEM_RESULT); return i; };
	void SetExitCode(int i) { m_SharedMem.Write((unsigned char*)&i, sizeof(int), SHARED_MEM_RESULT); };
	//Z0008, LT - koniec
};

// EOF //////////////////////////////////////////////////////////////////////
