///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/23 14:07:10 $
//         $Locker:  $
//         $Revision: 1.8 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Komunikacja sieciowa
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: netdatag.h,v $
// Revision 1.8  2004/06/23 14:07:10  ltokarski
// no message
//
// Revision 1.7  2004/06/23 08:40:32  ltokarski
// Z0006 - zmienne numery portow
//
// Revision 1.5  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#ifndef _NetDatagram_h_
#define _NetDatagram_h_


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>

class CNetDatagram;
//class CUPSSrv;

class CNetDatagram
{
public:
   CNetDatagram();
   ~CNetDatagram();

   BOOL Connect(/*CUPSSrv *UPSSrv,*/ unsigned int Port, UINT serverPort);	//Z0006, LT - rowniez port serwera
   void Disconnect();
   int Receive();
   int OnReceive(UCHAR *Addr,BYTE *type,int *DataLen);
   void Acknowledge();
   BOOL SendTo(LPCTSTR Addr, BYTE Type, BYTE *Data=NULL, int DataLen=0);

protected:
	UINT sPort;		//Z0006, LT - numer portu serwera
   //CUPSSrv *m_UPSSrv;
   //CDatagramSock *m_Socket;

   int volatile m_Socket;

   int                  serlen,clilen;
   struct sockaddr_in	add_ser;
   struct sockaddr_in	add_cli;


   //void OnReceive(int nErrorCode);

   BOOL CheckPacket(BYTE *Buff, int Len);
   unsigned short CalcCRC(BYTE *Buff, int Len);
};

#endif // _NetDatagram_h_

// EOF //////////////////////////////////////////////////////////////////////
