///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/23 12:30:06 $
//         $Locker:  $
//         $Revision: 1.6 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Komunikacja sieciowa
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: netdatag.h,v $
// Revision 1.6  2004/06/23 12:30:06  ltokarski
// Z0003 - uzywanie portow IP pobranych z pliku opcji
//
// Revision 1.5  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _NetDatagram_h_
#define _NetDatagram_h_

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>

class CNetDatagram;
class CUPSSrv;

///*
//class CDatagramSock : public CAsyncSocket
//{
//public:
//	CDatagramSock(CNetDatagram *Net);
//	virtual ~CDatagramSock();
//
//protected:
//   CNetDatagram *m_Net;
//
//	virtual void OnReceive(int nErrorCode);
//};
//*/

class CNetDatagram
{
  // friend class CDatagramSock;
public:
   CNetDatagram();
   ~CNetDatagram();

   BOOL Connect(CUPSSrv *UPSSrv, UINT sPort, UINT cPort);	//Z0003, LT - nowe parametry: porty IP
   void Disconnect();
   BOOL SendTo(LPCTSTR Addr, BYTE Type, BYTE *Data=NULL, int DataLen=0);
   void OnReceive(int nErrorCode);

protected:
   CUPSSrv *m_UPSSrv;
   //CDatagramSock *m_Socket;

   int 	m_Socket;
   int                  serlen,clilen;
   struct sockaddr_in	add_ser;
   struct sockaddr_in	add_cli;
   UINT	clientPortIP;	//Z0003, LT - do przekazywania wartosci do SendTo

   BOOL CheckPacket(BYTE *Buff, int Len);
   unsigned short CalcCRC(BYTE *Buff, int Len);
};

#endif // _NetDatagram_h_

// EOF //////////////////////////////////////////////////////////////////////
