///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/09 11:32:03 $
//         $Locker:  $
//         $Revision: 1.3 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Komunikacja z zasilaczami stykowymi
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upsjoint.h,v $
// Revision 1.3  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _UPSJoint_h_
#define _UPSJoint_h_

class CUPSJoint : public CUPSGeneric
{
public:
   CUPSJoint(CUPSThreadInfo *Info);
   ~CUPSJoint();

protected:
   BYTE m_CTS;                  // poprzedni stan sygnalow modemowych
   BYTE m_DCD;                  // poprzedni stan sygnalow modemowych
	BYTE m_IsTurningOff;		// 2003.01.16, MW, poprawa obslugi wylaczania UPS-a stykowego bez zamykania OS



   BOOL OpenUPS();
   void CloseUPS();
   BOOL GetStaticData();
   BOOL GetDynamicData();
   BOOL DoSetAutostart(BOOL Autostart);
   BOOL DoTurnOff(BOOL SetAutostart ,BYTE JointCloseOpt=0);
   BOOL DoRestart();
   time_t m_clock();
};

#endif // _UPSJoint_h_

// EOF //////////////////////////////////////////////////////////////////////
