///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/09 11:32:03 $
//         $Locker:  $
//         $Revision: 1.3 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Komunikacja przez protok Smartmon
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upssmart.h,v $
// Revision 1.3  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _UPSSmartmon_h_
#define _UPSSmartmon_h_

class CUPSSmartmon : public CUPSGeneric
{
public:
   CUPSSmartmon(CUPSThreadInfo *Info);
   ~CUPSSmartmon();

protected:
   char m_AvailPar[89+1];     // dostepne parametry - jest +1 poniewaz ID sa
                              // takie jak w protokole (m_AvailPar[0] jest
                              // niewykorzystany)

   BOOL OpenUPS();
   void CloseUPS();
   BOOL GetStaticData();
   BOOL GetDynamicData();
   BOOL DoSetAutostart(BOOL Autostart);
   BOOL DoTurnOff(BOOL SetAutostart,BYTE JointCloseOpt=0);
   BOOL DoRestart();

   BOOL SendAndGetResponse(LPCTSTR Cmd, BYTE *Buff, int &Len);
   void SendPacket(LPCTSTR Cmd);
   BOOL GetPacket(BYTE *Buff, int &Len);
   BOOL CheckPacket(BYTE *Buff, int Len);
   long GetNum(BYTE *Buff, int &Offset);
};

#endif // _UPSSmartmon_h_

// EOF //////////////////////////////////////////////////////////////////////
