///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/08 15:08:46 $
//         $Locker:  $
//         $Revision: 1.9 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Operacje na stringach
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: cstr.cpp,v $
// Revision 1.9  2004/07/08 15:08:46  ltokarski
// Z0014 - poprawione bledy w CString
//
// Revision 1.8  2004/07/07 15:01:05  ltokarski
// Poprawki drobne
//
// Revision 1.7  2004/07/05 09:09:43  ltokarski
// Z0011 - rozne drobne poprawki (html cd., blad waitpid, taby przed warningiem, CString operator ==, wyciete debugi)
//
// Revision 1.6  2004/06/09 11:31:06  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#include <stdio.h>
//#include <iostream.h>
//#include <ostream.h>
//#include <istream.h>
#include <string.h>


#include "cstr.h"

#define DEBUG_VAL 0
#define DEBUG_C

//const CUPSEventCfg& CUPSEventCfg::operator=(const CUPSEventCfg &Event)

CString CString::operator + (CString & str)
{
#ifdef DEBUG_C
	if(Debug)
		printf("+ %s\n",(LPCTSTR)s);
#endif

	CString s1;

	//printf("+ %s\n",(LPCTSTR)s);
	if(tmp!=NULL)
	{
		DELETE_ tmp;
		tmp=NULL;
	}
	if(s1.s)
	{
		DELETE_ s1.s;
		s1.s=NULL;
	}
	s1.s = new char [str.GetSize()+strlen(s)+2+EXTRA_SIZE];
	memset(s1.s,0,str.GetSize()+strlen(s)+2);
	strcpy(s1.s,s);
	strcat(s1.s,(LPCTSTR)str);
//if(Debug)
  //	printf("Retur & s1\n");
	return s1;
}


CString CString::operator + (char *str)
{
#ifdef DEBUG_C
	if(Debug)
		printf("+ %s\n",(LPCTSTR)s);
#endif

	CString s2;

	if(tmp!=NULL)
	{
		DELETE_ tmp;
		tmp=NULL;
	}
	if(s2.s)
	{
		DELETE_ s2.s;
		s2.s=NULL;
	}
	s2.s = new char [strlen(str)+strlen(s)+2+EXTRA_SIZE];
	memset(s2.s,0,strlen(str)+strlen(s)+2);
	strcpy(s2.s,s);
	strcat(s2.s,str);
//if(Debug)
  //	printf("Retur & s2\n");
	return s2;
}


///////////////////////////////////////////////
CString& CString::operator += (CString & str)
{
#ifdef DEBUG_C
	if(Debug)
		printf("+= %s\n",(LPCTSTR)s);
#endif

	if(tmp!=NULL)
	{
		DELETE_ tmp;
		tmp=NULL;
	}
	t_size=str.GetSize();
	tmp=new char[strlen(s)+t_size+2+EXTRA_SIZE];//nowy
	memset(tmp,0,t_size+strlen(s));
	strcpy(tmp,s);
	strcat(tmp,(LPCTSTR)str);
	DELETE_ s;
	s=NULL;
	s_size=strlen(tmp);
	s=new char[s_size+1+EXTRA_SIZE];//nowy
	memset(s,0,s_size);
	strcpy(s,tmp);
	DELETE_ tmp;
	tmp=NULL;
	return 	*this;
}

///////////////////////////////////////////////
CString& CString::operator += (const char *str)
{
#ifdef DEBUG_C
	if(Debug)
		printf("+= %s\n",(LPCTSTR)s);
#endif

	if(tmp!=NULL)
	{
		DELETE_ tmp;
		tmp=NULL;
	}
	t_size=strlen(str);
	tmp=new char[strlen(s)+t_size+2+EXTRA_SIZE];//nowy
	memset(tmp,0,t_size+strlen(s));
	strcpy(tmp,s);
	strcat(tmp,str);
	DELETE_ s;
	s=NULL;
	s_size=strlen(tmp);
	s=new char[s_size+1+EXTRA_SIZE];//nowy
	memset(s,0,s_size);
	strcpy(s,tmp);
	DELETE_ tmp;
	tmp=NULL;
	return 	*this;
}

//////////////////////////
//
//
CString &  CString::operator = (const CString & str)
{
#ifdef DEBUG_C
	if(Debug)
	{
		printf("CString=%s l=%d \n",(LPCTSTR)str,str.GetLength());
		if(s)
			printf("CString=%s \n",(LPCTSTR)s);
	}
#endif

	if(s!=NULL)
	{
		DELETE_ s;
		s=NULL;
	}
	if(str.s == NULL)	//Z0014, LT - jak to ku...  bez tego dzialalo?!
		return *this;
	s_size=str.GetLength();
	s = new char[s_size+1+EXTRA_SIZE];
	memset(s,0,s_size+1);
	strcpy(s,(LPCTSTR)str);
	return *this;
}


/////////////////////////////////////////////////////////
CString &CString::operator = (const char *str)
{
	if(this->s!=NULL)
	{
		delete  this->s;
		if(Debug)
			printf("CStringS  del1 \n");
		this->s=NULL;
	}
	s_size=strlen(str)+1;
	this->s = new char[s_size+EXTRA_SIZE];
	this->s_size=strlen(str);
	memset(this->s,0,this->s_size+1);
	strcpy(this->s,str);
	if(Debug)
		printf("CStringS= del3 s=%d,tmp=%d\n",(int)this->s,(int)this->tmp);
	return *this;
}

//Z0011, LT
bool  CString::operator == (const CString & str)
{
	return (strcmp(this->s, str.s) == 0);
}

bool  CString::operator == (CString & str)
{
	return (strcmp(this->s, str.s) == 0);
}

bool  CString::operator == (char *str)
{
	return (strcmp(this->s, str) == 0);
}

bool  CString::operator == (const char *str)
{
	return (strcmp(this->s, str) == 0);
}
//Z0011, LT - koniec

////////////////////////////////////
char* CString::str()
{
#ifdef DEBUG_C
	if(Debug)
		printf("str\n");
#endif

	return this->s;
}


////////////////////////////////////
void CString::TrimRight()
{
	int is_s=0;
	for(int i=strlen(s)-1;i>=0;i--)
	{
		if(s[i]==' ')
		{
			s[i]=0;
			is_s=1;
		}
		else
		{
			if(is_s==0 && s[i]!=' ')
				break;
			if(is_s==1)
				break;
		}
	}
}

////////////////////////////////////
void CString::TrimLeft()
{
	char *t;
	int is_s=0;

	if(s[0]!=' ')
		return;
	t=NULL;
	t = new char[ strlen(this->s)+50];
	memset(t,0,strlen(this->s)+50);
	if(t==NULL)
		return;
	int j=0;
	for(int i=0;i<1000 && s[i];i++)
	{
		if(s[i]==' ' && is_s==0)
			continue;
		t[j++]=s[i];
		is_s=1;
	}
	t[j] = 0;	//Z0014, LT - tala mala bula
	strcpy(s,t);
	delete [] t;
}

////////////////////////////////////
void CString::MakeUpper()
{
	for(int i=0;s[i] && i<1000;i++)
		if(s[i]>='a' && s[i]<='z')
			s[i]-=32; //male
}

void CString::Format(char *patern,char b)
{
#ifdef DEBUG_C
	if(Debug)
		printf("Format\n");
#endif
//	printf("Error Format %d\n",(int)s);
	//Z0014, LT - brakuje alokacji!
	if(s)
		delete [] s;
	s = new char[strlen(patern) + 3];
	//Z0014, LT - koniec
	if(this->s)
		sprintf(s,patern,b);
	else
		printf("Error Format\n");
}

// tu blad
void CString::Format(char *patern,char *str)
{
#ifdef DEBUG_C
	if(Debug)
		printf("Format\n");
#endif
	if(this->s)
	{
		delete [] s;
		s=NULL;
	}
	s = new char[ strlen(patern)+50];
	memset(s,0,strlen(patern)+50);
	if(this->s)
		sprintf(this->s,patern,str);
	else
		printf("Error Format\n");
}

bool CString::Empty()
{
#ifdef DEBUG_C
	if(Debug)
		printf("Empty\n");
#endif
	if(strlen(this->s)>0)
		return 1;
	return 0;
}

///////////////////////
char* CString::Mid(int idx,int pos)
{
	if(this->s==NULL)
	{
		//blad
	}
	if(this->tmp!=NULL)
	{
		DELETE_ this->tmp;
		this->tmp=0;
	}
	this->tmp=new char[pos+1+EXTRA_SIZE];
	this->t_size=pos+1;
	memset(this->tmp,0,pos+1);
	strncpy(this->tmp,(char *)(this->s+idx),pos);
//printf("			Mid ret -%s-\n",tmp);
	return tmp;

}


////////////////////////////////////
int CString::GetSize()
{
#ifdef DEBUG_C
//if(Debug)
  //	printf("Getsi\n");
#endif
	if(this->s)
		return strlen(this->s);
	return 0;
}

int CString::Find(char *c,int idx)
{
//printf("Szukam od %d -%s- -%s- \n",idx,(char *)s,(char *)c);
#ifdef DEBUG_C
	if(Debug)
		printf("Find\n");
#endif
	if(this->s==NULL)
		return -1;
	for(int i=0;this->s[idx+i] ;i++)
	{
		if(strcmp((char *)this->s+idx+i,c)==0)
			return i;
	}
	return -1;

}

int CString::Find(char c,int idx)
{
#ifdef DEBUG_C
	if(Debug)
		printf("Find\n");
#endif
	if(this->s==NULL)
		return -1;
	for(int i=0; s[i+idx] ;i++)
		if(s[i+idx]==c)
			return i;
	return -1;
}

int CString::GetLength() const
{
	if(this->s)
		return strlen(this->s);
	return 0;
}

////////////////////////////////////
bool CString::IsEmpty()
{
#ifdef DEBUG_C
	if(Debug)
		printf("IsEm\n");
#endif
	if(this->s)
		if(strlen(this->s)==0)
			return 1;
	return 0;
}
////////////////////////////////////
CString::CString()
{
	Debug=DEBUG_VAL;
	this->s=NULL;
	//this->s=new char[1+EXTRA_SIZE];
	this->s_size=0;
	this->tmp=NULL;
	this->t_size=0;
	//this->tmp=new char[1+EXTRA_SIZE];
#ifdef DEBUG_C
	if(Debug)
		printf("C:C s=%d,tmp=%d \n",(int)this->s,(int)this->tmp);
#endif
}
////////////////////////////////////
CString::CString(char *str)
{
	Debug=DEBUG_VAL;
#define T_SIZE 255

	this->s=NULL;
	this->tmp=NULL;

	this->s=new char[strlen(str)+1+EXTRA_SIZE];
	s_size=strlen(str)+1;
#ifdef DEBUG_C
	if(Debug)
		printf("C:CS * %d -%s-\n",(int)(LPCTSTR)s,str);
#endif
	memset(this->s,0,s_size);
	strcpy(this->s,str);
//printf("C:C ret  %d -%s-\n",this->s,(char *)this->s);
}
////////////////////////////////////
CString::~CString()
{
#ifdef DEBUG_C
	if(Debug)
		printf("Dest obiekt -%d \n",(int)s);
#endif

	if(this->s)
	{
#ifdef DEBUG_C
//		if(Debug)
//			printf("		Dest obiekt s=%s i name=%s-  str_add=%d \n",s,this->name,(int)this->s);
#endif
		DELETE_ s;
		s=NULL;
	}
	//printf("tmp\n");
#ifdef DEBUG_C
	if(Debug)
		printf("	Dest tmp=%d\n",(int)this->tmp);
#endif
	if(this->tmp)
	{

		DELETE_ this->tmp;
		this->tmp=NULL;
	}
//printf("Dest---------\n");
}
