///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/07 15:01:22 $
//         $Locker:  $
//         $Revision: 1.7 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Operacje na stringach
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: cstr.h,v $
// Revision 1.7  2004/07/07 15:01:22  ltokarski
// Poprawki drobne
//
// Revision 1.6  2004/07/05 09:09:43  ltokarski
// Z0011 - rozne drobne poprawki (html cd., blad waitpid, taby przed warningiem, CString operator ==, wyciete debugi)
//
// Revision 1.5  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////


#ifndef _CSTRINGH
#define _CSTRINGH

//#include <iostream>
//#include <istream>
//#include <ostream>
//#include <istream>
#include <string>
#include <stdio.h>


#define EXTRA_SIZE 0 //2000000
#define DELETE_ delete []
//#define DELETE_ delete

//typedef const char * LPCTSTR;
typedef char * LPCTSTR;


class CString
{
public:
	int Debug;
	CString();
	CString(char *);
	CString(CString & x)
	{
		//printf("contr &,%d\n",x.s);
		if(x.Debug)
		{
			printf("contr &,%s\n",x.s);
			printf("contr & memset ,this->s=%d \n",(int)this->s);
		}
		//LT - niebezpieczne!
		//memset(this,0,sizeof(CString));
		s = tmp = NULL;
		s_size = t_size = Debug = 0;
		//LT - koniec
		if(x.Debug)
		{
			printf("contr &,x.s=%d \n",(int)x.s);
			printf("contr &,this->s=%d \n",(int)this->s);
		}
		//*this  = x;
		if(this->s)
			DELETE_ this->s;
		this->s=new char [strlen(x.s)+1+EXTRA_SIZE];
		this->tmp=NULL;
		strcpy(this->s,x.s);
		if(x.Debug)
		{
		//strcpy(this->s,"AA");
			printf("contr &,this->s=%d \n",(int)this->s);
			printf("contr &,t->s=%d x.s=%d \n",(int)this->s,(int)x.s);
			printf("contr &,t->s=%s x.s=%s \n",this->s,x.s);
		}
	}
	~CString();
	int GetSize();
	bool IsEmpty();
	bool Empty();
	void Format(char *patern,char b);
	void Format(char *patern,char *str);
	int GetLength() const ;
	int Find(char *c,int idx);
	int Find(char c,int idx);
	char* Mid(int idx,int pos);
	char *str();
	void TrimRight();
	void TrimLeft();
	void MakeUpper();

	// &
	char   operator[](int x)
	{
		return s[x];
	}

	//char *    operator + (char * str);
	CString  operator + (CString &str);
	CString operator + (char *str);
	CString & operator = (const char *str);
	CString & operator = (const CString & str);

	CString & operator += (CString & str);
	CString & operator += (const char *str);

	bool operator == (const CString & str);	//Z0011, LT
	bool operator == (CString & str);	//Z0011, LT
	bool operator == (const char *str);		//Z0011, LT
	bool operator == (char *str);		//Z0011, LT

    operator LPCTSTR () const
    {
    	char * x = s;
       	return x;
    }
//    char name[100];

protected:
	char *s;
	char *tmp;
	int s_size;
	int t_size;
};
#endif
