///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/05 09:09:43 $
//         $Locker:  $
//         $Revision: 1.11 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Zapis do logw
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upslog.cpp,v $
// Revision 1.11  2004/07/05 09:09:43  ltokarski
// Z0011 - rozne drobne poprawki (html cd., blad waitpid, taby przed warningiem, CString operator ==, wyciete debugi)
//
// Revision 1.10  2004/07/02 09:12:54  ltokarski
// Z0010 - drobne poprawki w html
//
// Revision 1.9  2004/06/23 14:07:10  ltokarski
// no message
//
// Revision 1.8  2004/06/23 08:40:32  ltokarski
// Z0005 - zmienne sciezki instalacji
//
// Revision 1.6  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "cstr.h"
#include "linux_ty.h"
#include "upsmon.h"
#include "upsconfig.h"
#include "upslog.h"

extern int __debug;

void	Windows2ISO(const char *s, char *d);

/////////////////////////////////////////////////////////////////////////////
CUPSLog::CUPSLog()
{
	//m_AllUPS=NULL;
} // CUPSLog::CUPSLog


/////////////////////////////////////////////////////////////////////////////
void CUPSLog::Init(/*CTypedPtrArray<CObArray,CUPSConfig*> *AllUPS*/)
{
	//m_AllUPS=AllUPS;
} // CUPSLog::Init


/////////////////////////////////////////////////////////////////////////////
BOOL CUPSLog::Add(CUPSConfig *UPS, BYTE Color, LPCTSTR Str/*, CColorListBox *List*/)
{
	FILE *f;
	time_t tCzas;
	if(__debug)
		printf("Log: %s\n\r", Str);

	time(&tCzas);
	//Z0005, LT - sciezka nie jest stala, tylko czytana z opcji
//	if ((f = fopen(LOG_FILE_NAME,"a+")) == NULL )
	CString s = UPS->m_pathLog + LOG_FILE_NAME;
	if ((f = fopen(s.str(), "a+")) == NULL )
	{
		//printf("\r\nSciezka -%s-\n\r",LOG_FILE_NAME);
//		perror("Open file :       ");
		perror(LOG_FILE_NAME);
		return 0; /* cant open log file ! */
	}
	//Z0011, LT - wycinam \n\r (jest juz \n w czasie) i upraszczam zapis
//	if(UPS)
//		fprintf(f,"[UPS_IP] %s , %s , %s\n\r", UPS->m_IP, Str, ctime(&tCzas));
//	else
//		fprintf(f,"[UPS_IP] %s , %s , %s\n\r", "???", Str, ctime(&tCzas));
	fprintf(f,"[UPS_IP] %s, %s, %s", UPS? UPS->m_IP: "???", Str, ctime(&tCzas));
	//Z0011, LT - koniec
	int res=fclose (f);
	if(res!=0)
		perror("FClose :");

	char l[255];
	sprintf(l, "%sups%ldlog.html", (char *)UPS->m_pathLogWWW, UPS->m_UPSId+1);	//Z0010, LT - bylo: htm
	if ((f = fopen(l,"a+")) == NULL )
	{
		perror("Open file :       ");
		return 0; /* cant open log file ! */
	}
//	fprintf(f,"%s , %s<br>",ctime(&tCzas),Str);
	Windows2ISO(Str, l);
	fprintf(f, "%s , %s<br>", ctime(&tCzas), l);
	res=fclose (f);
	if(res==0)
		return 1;
	else
		perror("FClose :");
	return 0;
} // CUPSLog::Add

/////////////////////////////////////////////////////////////////////////////
// gdy Id==0 to kasujemy wszystkie wpisy
BOOL CUPSLog::Del(DWORD Id)
{
	return TRUE;
} // CUPSLog::Del

// EOF //////////////////////////////////////////////////////////////////////
