///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/29 10:19:25 $
//         $Locker:  $
//         $Revision: 1.4 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Obsuga portu szeregowego
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: comport.h,v $
// Revision 1.4  2004/06/29 10:19:25  ltokarski
// Z0008 - wejscie w tlo po zainicjowaniu komunikacji i zwracanie kodu bledu
//
// Revision 1.3  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _ComPort_h_
#define _ComPort_h_

class CComPort
{
public:
   CComPort();
   ~CComPort();

//   bool Open(int Port,char *str);
   bool Open(char *Port, char *str);
   bool IsOpen();
   void Close();

   int ReadChar();
   bool WriteChar(BYTE Char);
   bool WriteStr(BYTE *Str, int Len);

   bool SetState(BYTE RTS, BYTE DTR);
   bool GetState(BYTE &CTS, BYTE &DCD);

   class CUPSThreadInfo *m_Info;
protected:
   int m_PortNum;
   HANDLE m_RSHandle;
};

#endif // _ComPort_h_

// EOF //////////////////////////////////////////////////////////////////////
