///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/30 16:44:31 $
//         $Locker:  $
//         $Revision: 1.4 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Pami dzielona
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: smem.h,v $
// Revision 1.4  2004/06/30 16:44:31  ltokarski
// Z0009 - uporzadkowanie pamieci dzielonej
//
// Revision 1.3  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _SharedMemory_h_
#define _SharedMemory_h_

#define SIZE_SH_MEM 100
struct ShMemStr
{
	int flag;
	char t[255];
};

class CSharedMemory
{
public:
   CSharedMemory();
   ~CSharedMemory();

   BOOL Create();	//Z0009, LT - wyciete nieuzywane parametry
   void Destroy();

   BOOL Set(BYTE Ch, DWORD Len, DWORD Offset);
   BOOL Write(BYTE *Buff, DWORD Len, DWORD Offset=0);
   BOOL Read(BYTE *Buff, DWORD Len, DWORD Offset=0);

private:
	void *ShMem;
	struct ShMemStr *ShMemS;
	int shmid;

   DWORD m_Size;
};

#endif // _SharedMemory_h_

// EOF //////////////////////////////////////////////////////////////////////
