///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/09 11:32:03 $
//         $Locker:  $
//         $Revision: 1.3 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Komunikacja z zasilaczami Orion
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upsorion.h,v $
// Revision 1.3  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _UPSOrion_h_
#define _UPSOrion_h_

class CUPSOrion : public CUPSGeneric
{
public:
   CUPSOrion(CUPSThreadInfo *Info);
   ~CUPSOrion();

protected:
	BYTE	m_UPSType;
	BYTE	m_UPSOutPower;

	BOOL OpenUPS();
	void CloseUPS();
	BOOL GetStaticData();
	BOOL GetDynamicData();
	BOOL DoSetAutostart(BOOL Autostart);
	BOOL DoTurnOff(BOOL SetAutostart,BYTE JointCloseOpt=0);
	BOOL DoRestart();

	BOOL SendAndGetResponse(LPCTSTR Cmd, BYTE *Buff, int &Len);
	void SendPacket(LPCTSTR Cmd);
	BOOL GetPacket(BYTE *Buff, int &Len, LPCTSTR Cmd);
	BOOL CheckPacket(BYTE *Buff, int Len, LPCTSTR Cmd);
	long GetNum(BYTE *Buff, int &Offset);
};

#endif // _UPSOrion_h_

// EOF //////////////////////////////////////////////////////////////////////

